package cn.timer.api.bean.spmk;

import java.util.Date;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author Tang 2020-04-17
 */
@Entity
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "spmk_approve_summary")
@ApiModel("审批汇总")
public class SpmkApproveSummary extends Model<SpmkApproveSummary> {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue
	@TableId(type = IdType.AUTO)
	@ApiModelProperty(value = "审批编号 审批编号", example = "101")
	private Integer id;

	@ApiModelProperty(value = "企业组织代码", example = "123")
	private Integer orgCode;
	
	@ApiModelProperty(value = "发起人id 用于搜索（所在部门）", example = "101")
	private Integer empNum;

	@ApiModelProperty(value = "标题 ", example = "标题")
	private String title;

	@ApiModelProperty(value = "所在部门名称 ", example = "所在部门名称")
	private String departmentName;

	@ApiModelProperty(value = "发起人名称 ", example = "发起人名称")
	private String initiator;

	@ApiModelProperty(value = "发起时间 ", example = "发起时间")
	private Date createTime;

	@ApiModelProperty(value = "审批名称 ", example = "审批名称")
	private String approveName;

	@ApiModelProperty(value = "状态 0审批中 1审批撤销 2审批拒绝 3审批通过/审批完成", example = "101")
	private Integer sts;

	@ApiModelProperty(value = "当前审批人 ", example = "当前审批人")
	private String currentApprover;

	@ApiModelProperty(value = "历史审批人 ", example = "历史审批人")
	private String historyApprover;

	@ApiModelProperty(value = "最近处理时间 ", example = "最近处理时间")
	private Date updateTime;

	@ApiModelProperty(value = "结束时间 ", example = "结束时间")
	private Date endTime;

	@ApiModelProperty(value = "摘要 ", example = "摘要")
	private String digest;

}