package cn.timer.api.bean.spmk;

import javax.persistence.Entity;
import javax.persistence.Table;

import com.baomidou.mybatisplus.extension.activerecord.Model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 审批发起人配置
 * 
 * @author Tang 2020-04-17
 */
@Entity
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "spmk_approve_execute_record")
@ApiModel("审批执行记录")
public class SpmkInitiatorConfig extends Model<SpmkInitiatorConfig> {
	private static final long serialVersionUID = 1L;

	/**
	 * 编号
	 */
	@ApiModelProperty(value = "编号 ", example = "1")
	private Integer id;

	/**
	 * 自定义审批id
	 */
	@ApiModelProperty(value = "自定义审批id", example = "100")
	private Integer customApprovalId;

	/**
	 * 关联id
	 */
	@ApiModelProperty(value = "关联id", example = "100")
	private Integer assoId;

	/**
	 * 类型
	 */
	@ApiModelProperty(value = "类型", example = "100")
	private Integer type;

}