package cn.timer.api.dto.spmk;

import java.util.List;

import cn.hutool.json.JSONSupport;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class Router extends JSONSupport {

	/**
	 * 节点类型
	 * 1.creator-发起 
	 * 2.audit-审批  
	 * 3.copy-抄送
	 * 4.rules-规则
	 */
	private String className;
	
	/**
	 * 执行
	 */
	private String execute;

	/**
	 * 通过
	 */
	private Boolean flow;
	
	/**
	 * 关系
	 */
	private List<Relation> relation;
	
	/**
	 * 条件
	 */
	private List<Condition> condition;
	
	/**
	 * 下一级
	 */
	private List<Router> children;
	
}
