package cn.timer.api.dto.spmk;

import java.util.Date;

import javax.persistence.Entity;

import cn.hutool.json.JSONObject;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

@Entity
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class SpmkApprovalTemplateDto {

	@ApiModelProperty(value = "编号 编号", example = "101")
	private Integer id;

	@ApiModelProperty(value = "审批模板组id 当前用户ID", example = "101")
	private Integer approvalTemplateGId;

	@ApiModelProperty(value = "审批图标地址 ", example = "审批图标地址")
	private String iconUrl;

	@ApiModelProperty(value = "审批名称 ", example = "审批名称")
	private String name;

	@ApiModelProperty(value = "审批说明 ", example = "审批说明")
	private String description;

	@ApiModelProperty(value = "审批开关 0启用 1停用", example = "101")
	private Integer isOpen;

	@ApiModelProperty(value = "排序 由于区分关键字，命名后缀加s", example = "101")
	private Integer ranks;

	@ApiModelProperty(value = "审批意见 是否必填 意见 0是 1否", example = "101")
	private Integer isOpinion;

	@ApiModelProperty(value = "更新时间 ", example = "更新时间")
	private Date updateTime;

	@ApiModelProperty(value = "创建时间 ", example = "创建时间")
	private Date createTime;
	
	@ApiModelProperty(value = "关联类型 1转正 2离职 3调薪 4调岗 5加班 6请假 7出差 8外出 9补卡", example = "2")
	private Integer assoType;

	@ApiModelProperty(value = "审批表单 ", example = "审批表单")
	private JSONObject froms;

	@ApiModelProperty(value = "审批流程 ", example = "审批流程")
	private Router router;
	
}
