package cn.timer.api.utils;

import java.util.ArrayList;
import java.util.List;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;

import cn.hutool.core.lang.Console;
import cn.hutool.core.util.NumberUtil;
import cn.hutool.json.JSONObject;
import cn.timer.api.bean.yggl.YgglMainEmp;
import cn.timer.api.bean.zzgl.ZzglBmgwM;
import cn.timer.api.dto.spmk.Condition;
import cn.timer.api.dto.spmk.Relation;
import cn.timer.api.dto.spmk.Router;
import cn.timer.api.dto.spmk.User;

/**
 * 流程节点工具类
 * 
 * @author Administrator
 *
 */
public class RouterUtils {
	
	private final static String UNEXECUTED = "0";
	private final static String EXECUTING = "1";
	private final static String EXECUTED = "2";
	private final static String CREATOR = "creator";
	private final static String RULES = "rules";
	private final static String AUDIT = "audit";
	private final static String COPY = "copy";
	private final static String RELATION_TYPE_DEPARTMENT = "department";
	private final static String RELATION_TYPE_USERS = "users";


	// 执行下一个节点
	public static List<Router> NextNode(List<Router> listRouter,JSONObject obj) {
		
		Router router;
		if (listRouter != null && listRouter.size() != 0) {
			// 非条件节点
			if (listRouter.size() == 1) {
				router = listRouter.get(0);
				if (router.getExecute() == null) {
					System.out.println("默认UNEXECUTED");
					router.setExecute(UNEXECUTED);
				}
				// 0未执行 1执行中 2已执行
				switch (router.getExecute()) {
				case UNEXECUTED:
					switch (router.getClassName()) {
					case CREATOR:
						Console.log("发起人逻辑");
						router.setExecute(EXECUTED);
						router.setFlow(true);
						router.getRelation().get(0).setName(obj.get("name",String.class));
						NextNode(router.getChildren(),obj);
						break;
					case AUDIT:
						Console.log("审批人逻辑");
						router.setExecute(EXECUTING);
						router.setFlow(true);
						
						List<User> listUser = router.getRelation().get(0).getUsers();
						user:
							for (int i = 0; i < listUser.size(); i++) {
								String execute = listUser.get(i).getExecute();
								switch (execute) {
								case UNEXECUTED:
									listUser.get(i).setExecute(EXECUTING);
									break user;
								case EXECUTING:
									listUser.get(i).setExecute(EXECUTED);
									break;
								}
							}
						break;
					case COPY:
						Console.log("抄送人逻辑");
						router.setExecute(EXECUTED);
						router.setFlow(true);
						List<Relation> listRelations = router.getRelation();
						for (int i = 0; i < listRelations.size(); i++) {
							// 装配 部门人员
							if (RELATION_TYPE_DEPARTMENT.equals(listRelations.get(i).getType())) {
								List<YgglMainEmp> listYgglMainEmp = selectOtherlistent(obj.get("orgCode",Integer.class), Integer.valueOf(listRelations.get(i).getDepartmentId()));
								
								List<User> listUsers = new ArrayList<User>();
								for (YgglMainEmp emp : listYgglMainEmp) {
									User user = new User();
									user.setName(emp.getName());
									user.setId(String.valueOf(emp.getEmpNum()));
									listUsers.add(user);
								}
								listRelations.get(i).setUsers(listUsers);
							}else if (RELATION_TYPE_USERS.equals(listRelations.get(i).getType())) {
								// 直接跳过，此处 else if代码段 只做说明，可不写
							}
						}
						NextNode(router.getChildren(),obj);
						break;
					default:
						break;
					}
					break;
				case EXECUTING:
					switch (router.getClassName()) {
					case AUDIT:
						Console.log("下一个审批人逻辑");
						router.setFlow(true);
						boolean executeFlog = true;
						List<User> listUser = router.getRelation().get(0).getUsers();
						user:
							for (int i = 0; i < listUser.size(); i++) {
								String execute = listUser.get(i).getExecute();
								switch (execute) {
								case UNEXECUTED:
									listUser.get(i).setExecute(EXECUTING);
									if (!EXECUTED.equals(listUser.get(i).getExecute())) {
										executeFlog = false;
									}
									break user;
								case EXECUTING:
									listUser.get(i).setExecute(EXECUTED);
									break;
								}
							}
						if (executeFlog) {
							router.setExecute(EXECUTED);
						}
						
						NextNode(router.getChildren(),obj);
						break;
					default:
						break;
					}
					break;
				case EXECUTED:
					Console.log("下一个节点");
					NextNode(router.getChildren(),obj);
					break;
				}
				
			} else {
				// 条件节点
				rulefor:
				for (Router routerRule : listRouter) {
					switch (routerRule.getExecute()) {
					case UNEXECUTED:
						boolean condition_b = true;
						List<Condition> listCondition = routerRule.getCondition();
						if (listCondition == null || listCondition.size() == 0) {
							routerRule.setFlow(true);
						}else {
							for (Condition condition : listCondition) {
								// 判断条件
								if (!stringCompare(obj.get(condition.getKey(),String.class), condition.getValue(), condition.getFormat())) {
									condition_b = false;
								}
							}
						}
						
						routerRule.setFlow(condition_b);
						routerRule.setExecute(EXECUTED);
						if (routerRule.getFlow() == true) {
							Console.log("条件逻辑");
							NextNode(routerRule.getChildren(),obj);
						}
						break;
					case EXECUTED:
						NextNode(routerRule.getChildren(),obj);
						break rulefor;
					}
					
				}
				Console.log("特殊情况!");
			}
		}
		
		return listRouter;

	};
	
	// 执行下一个节点
	public static List<Router> NextNode_bak(List<Router> listRouter,JSONObject obj) {
		
		Router router;
		if (listRouter != null && listRouter.size() != 0) {
			// 非条件节点
			if (listRouter.size() == 1) {
				router = listRouter.get(0);
				// 0未执行 1执行中 2已执行
				switch (router.getExecute()) {
				case UNEXECUTED:
					switch (router.getClassName()) {
					case CREATOR:
						Console.log("发起人逻辑");
						router.setExecute(EXECUTED);
						router.setFlow(true);
						router.getRelation().get(0).setName(obj.get("name",String.class));
						NextNode(router.getChildren(),obj);
						break;
					case AUDIT:
						Console.log("审批人逻辑");
						router.setExecute(EXECUTING);
						router.setFlow(true);
						
						List<User> listUser = router.getRelation().get(0).getUsers();
						user:
							for (int i = 0; i < listUser.size(); i++) {
								String execute = listUser.get(i).getExecute();
								switch (execute) {
								case UNEXECUTED:
									listUser.get(i).setExecute(EXECUTING);
									break user;
								case EXECUTING:
									listUser.get(i).setExecute(EXECUTED);
									break;
								}
							}
						break;
					case COPY:
						Console.log("抄送人逻辑");
						router.setExecute(EXECUTED);
						router.setFlow(true);
						List<Relation> listRelations = router.getRelation();
						for (int i = 0; i < listRelations.size(); i++) {
							// 装配 部门人员
							if (RELATION_TYPE_DEPARTMENT.equals(listRelations.get(i).getType())) {
								List<YgglMainEmp> listYgglMainEmp = selectOtherlistent(obj.get("orgCode",Integer.class), Integer.valueOf(listRelations.get(i).getDepartmentId()));
								
								List<User> listUsers = new ArrayList<User>();
								for (YgglMainEmp emp : listYgglMainEmp) {
									User user = new User();
									user.setName(emp.getName());
									user.setId(String.valueOf(emp.getEmpNum()));
									listUsers.add(user);
								}
								
							}else if (RELATION_TYPE_USERS.equals(listRelations.get(i).getType())) {
								
							}
						}
						NextNode(router.getChildren(),obj);
						break;
					default:
						break;
					}
					break;
				case EXECUTING:
					switch (router.getClassName()) {
					case AUDIT:
						Console.log("下一个审批人逻辑");
						
						router.setFlow(true);
						boolean executeFlog = true;
						List<User> listUser = router.getRelation().get(0).getUsers();
						user:
							for (int i = 0; i < listUser.size(); i++) {
								String execute = listUser.get(i).getExecute();
								switch (execute) {
								case UNEXECUTED:
									listUser.get(i).setExecute(EXECUTING);
									if (!EXECUTED.equals(listUser.get(i).getExecute())) {
										executeFlog = false;
									}
									break user;
								case EXECUTING:
									listUser.get(i).setExecute(EXECUTED);
									break;
								}
							}
						if (executeFlog) {
							router.setExecute(EXECUTED);
						}
						
						NextNode(router.getChildren(),obj);
						break;
					default:
						break;
					}
					break;
				case EXECUTED:
					Console.log("下一个节点");
					NextNode(router.getChildren(),obj);
					break;
				}
				
			} else {
				// 条件节点
				rulefor:
				for (Router routerRule : listRouter) {
					switch (routerRule.getExecute()) {
					case UNEXECUTED:
						boolean condition_b = true;
						List<Condition> listCondition = routerRule.getCondition();
						if (listCondition == null || listCondition.size() == 0) {
							routerRule.setFlow(true);
						}else {
							for (Condition condition : listCondition) {
								// 判断条件
								if (!stringCompare(obj.get(condition.getKey(),String.class), condition.getValue(), condition.getFormat())) {
									condition_b = false;
								}
							}
						}
						
						routerRule.setFlow(condition_b);
						routerRule.setExecute(EXECUTED);
						if (routerRule.getFlow() == true) {
							Console.log("条件逻辑");
							NextNode(routerRule.getChildren(),obj);
						}
						break;
					case EXECUTED:
						NextNode(routerRule.getChildren(),obj);
						break rulefor;
					}
					
				}
				Console.log("特殊情况!");
			}
		}
		
		return listRouter;
		
	};
	
	public static List<YgglMainEmp> selectOtherlistent(Integer orgCode, Integer id){
		ArrayList<Integer> list = new ArrayList<Integer>();
		QueryWrapper<ZzglBmgwM> queryWrapper = new QueryWrapper<ZzglBmgwM>();
		queryWrapper.eq("org_code", orgCode);
		List<ZzglBmgwM> zzglBmgwMs = ZzglBmgwM.builder().build().selectList(queryWrapper);
		list.add(id);
		ZzglBmgwM.getDepts(list, id, zzglBmgwMs);

		if (list == null || list.size() == 0) {
			return null;
		} else {
			LambdaQueryWrapper<YgglMainEmp> ygglMainEmpsLambdaQueryWrapper = new LambdaQueryWrapper<>();
			ygglMainEmpsLambdaQueryWrapper
					.select(YgglMainEmp::getId, YgglMainEmp::getEmpNum, YgglMainEmp::getName, YgglMainEmp::getPhone,
							YgglMainEmp::getBmgwId)
					.eq(YgglMainEmp::getOrgCode, orgCode).and(i -> i.in(YgglMainEmp::getBmgwId, list.toArray()));
			List<YgglMainEmp> ygglMainEmps = YgglMainEmp.builder().build().selectList(ygglMainEmpsLambdaQueryWrapper);
			return ygglMainEmps;
		}

	}
	
	private static boolean stringCompare(String s1,String s2,String symbol) {
		double d1;
		double d2;
		switch (symbol) {
		case "<":
			d1 = Double.parseDouble(s1);
			d2 = Double.parseDouble(s2);
			if (NumberUtil.compare(d1,d2) == -1) return true;
			break;
		case "<=":
			d1 = Double.parseDouble(s1);
			d2 = Double.parseDouble(s2);
			if (NumberUtil.compare(d1,d2) == -1 || NumberUtil.compare(d1,d2) == 0) return true;
			break;
		case "=":
			if (s2.equals(s1)) return true;
			break;
		case ">":
			d1 = Double.parseDouble(s1);
			d2 = Double.parseDouble(s2);
			if (NumberUtil.compare(d1,d2) == 1) return true;
			break;
		case ">=":
			d1 = Double.parseDouble(s1);
			d2 = Double.parseDouble(s2);
			if (NumberUtil.compare(d1,d2) == 0 || NumberUtil.compare(d1,d2) == 1) return true;
			break;
		}
		return false;

	};
	

}
